s = Server.local;
s.waitForBoot {
    var module, sound;

    // Connect to OSC
    thisProcess.openUDPPort(5005);
    n = NetAddr.new("0.0.0.0", 5005);
    o = OSCFunc({ arg msg, time, addr, recvPort; [msg, time, addr, recvPort].postln; }, '/radio', n);
    //OSCFunc.trace(true); 

    // Create the synth definition and load it
    module = SynthDef.new("module", { 
        arg hue, saturation, value;
        var oscillator, noise, filter, panner, mixer;
        noise = WhiteNoise.ar(1);
        filter = BPF.ar(noise, MouseX.kr(220, 1000), MouseY.kr(0, 1)**4, MouseY.kr(2, 0.1));
        oscillator = SinOsc.ar(MouseX.kr(220, 1000)) * MouseY.kr(0.5, 0);
        mixer = Mix.ar([filter, oscillator]);
        panner = LinPan2.ar(mixer, 0.0);
        Out.ar(0, mixer);
    });
    module.load(s);
    s.sync;
    
    // Make a sound
    sound = Synth.new("module", [\hue, 440, \saturation, 100, \value, 500]);
};
